/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/

				
function trace(msg){
	if(msg instanceof Array || msg instanceof Object){
		console.log(JSON.stringify(msg));
	}
	else{
		console.log(msg);
	}
}

(function(mui, owner) {
	
	owner.initResources = function(session_key){
		console.log("init resources :"+session_key);
		resources = {};
		var restClient = new $.RestClient(serviceUrl);
		resources.signIn = restClient.add('signIns', { url: 'system/sign-ins' });
		
		if(session_key){
			resources.session = restClient.add('session', { url: 'system/sign-ins',
				ajax:{headers:{FWTOKEN:session_key}} });
			resources.users = restClient.add('users', { url: 'system/users',
				ajax:{headers:{FWTOKEN:session_key}} } );
			resources.userProfiles = restClient.add('userProfiles', { url: 'system/user-profiles',
				ajax:{headers:{FWTOKEN:session_key}} } );
			resources.contactCategories = restClient.add('contactCategories', { url: 'system/departments',
				ajax:{headers:{FWTOKEN:session_key}} } );
			resources.contacts = restClient.add('contacts', { url: 'system/user-contacts',
				ajax:{headers:{FWTOKEN:session_key}} } );
			resources.notifications = restClient.add('notifications', { url: 'system/user-notifications',
				ajax:{headers:{FWTOKEN:session_key}} } );
			resources.announcements = restClient.add('announcements', { url: 'system/announcements',
				ajax:{headers:{FWTOKEN:session_key}} } );
			resources.consultants = restClient.add('consultants', { url: 'xzly/consultants',
				ajax:{headers:{FWTOKEN:session_key}} } );
			resources.contactRequests = restClient.add('contactRequests', { url: 'system/contact-requests',
				ajax:{headers:{FWTOKEN:session_key}} } );
		}
	}

	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || mui.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length < 4) {
			return callback('账号最短为 4 个字符');
		}
		if (loginInfo.password.length < 4) {
			return callback('密码最短为 4 个字符');
		}
		
		var state = JSON.parse(plus.storage.getItem('$state') || '{}');
		var user = JSON.parse(plus.storage.getItem('$user') || '{}');
		var authed = 'false';
		
		if(user && user.user_name==loginInfo.account)
		{
			console.log(JSON.stringify(plus.networkinfo.getCurrentType()));
			if(plus.networkinfo.getCurrentType()==plus.networkinfo.CONNECTION_NONE){
				// check offline
				console.log("check offline");
				if(state.hash==window.md5(loginInfo.password))
				{
					console.log("check pass offline passed");
					authed = 'true';
				}
				else{
					console.log("check pass offline failed");
					authed = 'missmatched';
				}
			}
		}
		
		if (authed=='true') {
			return owner.createState(state, callback);
		} else {
			// try online check
			console.log('logining');
			var pushClientId = '';
			var pushClientInfo = plus.push.getClientInfo();
			if(pushClientInfo){
				pushClientId = pushClientInfo.clientid;
				pushClientText = 'getui.com:'+pushClientInfo.appid+":"+pushClientInfo.clientid;
			}
		    console.log( "获取客户端推送标识信息："+pushClientText);
			var postData = {
				"app":"mobile",
				"version": plus.runtime.version,
				"username":loginInfo.account,
				"password":loginInfo.password,
				"pushClientId":pushClientId
			};
			
			resources.signIn.create(postData).done(function(data){
//			userResouce.signIn(postData, function(data){
				console.log(data.user_id);
				
				var settings = app.getSettings();
				
				var session = data;
				session.pass_hash = data.session_key;
				
				//使用session初始化resources
				owner.initResources(data.session_key);
				
//				owner.loadLocalContacts();
				
				owner.downloadData(data, function(){
					
					session.hash = window.md5(loginInfo.password);
					
					owner.createState(session, callback);
				});
				
				
			}).error(function(e){
				console.log("loginError:"+JSON.stringify(e));
				if(e && e.responseText)
				{
					var result = JSON.parse(e.responseText);
					if(result && result.message){
						return callback(result.message);
					}
				}
				callback("登录失败");
			});
						
//			var xhr = new plus.net.XMLHttpRequest();
//			xhr.onerror=function(e){
//				var str="lengthComputable="+e.lengthComputable+"loaded="+e.loaded+";total="+e.total;
//				console.log("onerror: "+str);
//			}
//			xhr.setRequestHeader("Accept","application/json");
//			xhr.setRequestHeader("Content-Type","application/json");
//			xhr.onreadystatechange = function () {
//				switch ( xhr.readyState ) {
//					case 0:
//						console.log( "xhr请求已初始化" );
//					break;
//					case 1:
//						console.log( "xhr请求已打开" );
//					break;
//					case 2:
//						console.log( "xhr请求已发送" );
//					break;
//					case 3:
//							console.log(xhr.responseText);
//						console.log( "xhr请求已响应");
//						break;
//					case 4:
//						if ( xhr.status == 200 ) {
//							console.log(xhr.responseText);
//							console.log( "xhr请求成功" );
//						} else {
//							console.log(xhr.getAllResponseHeaders());
//							console.log(xhr.statusText);
//							console.log( "xhr请求失败："+xhr.readyState );
//						}
//						break;
//					default :
//						break;
//				}
//			}
//			xhr.open( "POST", "http://wechat.imeetu.cc/system/sign-ins" );
//			console.log(JSON.stringify(postData));
//			xhr.send(postData);
						
		}
	};
	
	owner.downloadData = function(state, doneCallback){
		console.log("download data begin...");
				
		var settings = app.getSettings();
		
		var contactLastUpdated = settings.contact_updated_at;
			console.log("local last updated:"+contactLastUpdated);
		//检查是否有更新
		resources.contacts.read('last-update').done(function(updateInfo){
			
			console.log("contacts last updated:"+JSON.stringify(updateInfo));
			
			// for debugging , this always false
			if(false && updateInfo && updateInfo.contact_updated_at<=contactLastUpdated)
			{
				console.log("don't need to download");
				doneCallback();
			}
			else{
				
				var $state = plus.storage.getItem('$state');
				var $localContactMapText = plus.storage.getItem("$localContactMaps");
//				var $user = plus.storage.getItem('$user');
//				var $userProfile = plus.storage.getItem('$userPrifle');
//				var $orgList = plus.storage.getItem('$orgList');
//				var $sysContacts = plus.storage.getItem('$sysContacts');
				
				plus.storage.clear();
				
				app.setSettings(settings);
				plus.storage.setItem('$state', $state);
				plus.storage.setItem('$localContactMaps', $localContactMapText);
//				plus.storage.setItem('$user', $user);
//				plus.storage.setItem('$userPrifle', $userPrifle);
//				plus.storage.setItem('$orgList', $orgList);
//				plus.storage.setItem('$sysContacts', $sysContacts);
				
				// read the new user info from server and saved into storage
				resources.users.read(state.user_id).done(function(data){
					// console.log(JSON.stringify(data));
					data.entityType = null;
					data._links = null;
					plus.storage.setItem('$user', JSON.stringify(data));
				});
				
				resources.userProfiles.read(state.user_id).done(function(data){
					// console.log(JSON.stringify(data));
					data.entityType = null;
					data._links = null;
					plus.storage.setItem('$userPrifle',JSON.stringify(data));
				});
	
				// read the org list into the storage
				resources.contactCategories.read({'per-page':999999}).done(function(data){
					//console.log(JSON.stringify(data));
					plus.storage.setItem('$orgList', JSON.stringify(data));
					
				});
				
				//全量更新
				resources.contacts.read({
						expand:'category,contactFields,myFollowingRelation,myStarredRelation',
						'per-page':999999}
				).done(function(data){
					console.log('got contact list '+data.length);
					
					console.log('data '+JSON.stringify(data));
					plus.storage.setItem('$sysContacts', JSON.stringify(data));
					
					var tex = plus.storage.getItem("$sysContacts");
					console.log("check if saved:"+tex);
					
					settings.contact_updated_at = updateInfo.contact_updated_at;
					app.setSettings(settings);
					
					setTimeout(function(){
						//遍历联系人，确保每个设定了同步到本地的联系人都同步过
						var localMap = owner.str2Json($localContactMapText, []);
						for(var i in data){
							var contact = data[i];
							if(contact.myFollowingRelation){
								var localInfo = localMap[contact.contact_id];
								if(!localInfo ||!localInfo.local_id || localInfo.updated_at<contact.updated_at){
									owner.syncToLocalContact(contact);
									console.log("sync localContact in download:"+contact.contact_id);
								}
							}
						}
					}, 100);
					// owner.refreshLocalContacts(data);
//						var contacts = owner.getIndexedLocalContacts();
//						owner.buildIndexedContactsHtml(contacts);
					
					doneCallback();
				})
				.error(function(error){
					console.log("下载联系人数据发生错误"+error.message);
				});
			}
		});
	};
	
	owner.hasPrivelege = function(privilege){
		var state = app.getState();
//		console.log(JSON.stringify(state));
		if(state && state.privileges instanceof Array){
			if(!privilege){
				return true;
			}
			for(var i in state.privileges){
				var pri = state.privileges[i];
				if(pri=="ALL" || pri==privilege || privilege.indexOf(pri)===0){
					return true;
				}
			}
		}
		return false;
	};
	
	owner.changePassword = function(newPassword, callback)
	{
		var user = app.getUser();
		if(user)
		{
			resources.users.update(user.user_id, {password:newPassword}).done(function(data){
				console.log(data);
				plus.storage.setItem("$user", data);
				if(callback)
				{
					callback();
				}
				else{
					mui.toast("密码已更新");
				}
			}).error(function(data){
				if(callback)
				{
					data = JSON.parse(data);
					if(data && data.message){
						callback(data.message);
					}
					else{
						callback("修改密码发生错误");
					}
				}
			});
		}
		else{
			console.log("error: no user");
		}
	};

	owner.createState = function(state, callback) {
		
		owner.setState(state);
		return callback();
	};


	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = plus.storage.getItem('$state') || "{}";
		var state = JSON.parse(stateText);
		if(!state){
			state={};
		}
		return state;
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		plus.storage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || mui.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		plus.storage.setItem('$settings', JSON.stringify(settings));
		console.log('set setting:'+JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = plus.storage.getItem('$settings') || "{}";
		var settings = JSON.parse(settingsText);
		if(!settings){
			settings = {};
		}
		return settings;
	};
	
	owner.getUser = function(){
		try{
			var userText = plus.storage.getItem('$user');
	//		mui.alert(userText);
			if(userText){
				user = owner.str2Json(userText);
				var profileText = plus.storage.getItem('$userPrifle');
	//			mui.alert(profileText);
				if(profileText){
					user.profile = owner.str2Json(profileText);
				}
				else{
					user.profile = {};
				}
			}
			else{
				user = {};
			}
	//		mui.toast(JSON.stringify(user));
			return user;
		}
		catch(e){
			return {};
		}
	}
	
	
	owner.getContacts = function(){
		return owner.getSysContacts();
	};
	
	owner.getOrgTree = function(){
		return owner.str2Json(plus.storage.getItem("$orgTree"));
	};
	
	owner.getOrgDeptPickerData = function(addAllItem){
		var allList = owner.str2Json(plus.storage.getItem("$orgList"));
		var list = [];
		for(var i in allList)
		{
			var item = allList[i];
			if(item.category_type=='organization'){
				list.push({
					text: item.category_name,
					value: item.department_id,
					children: []
				}); 
			}
		}
		for(var i in list){
			var org = list[i];
			
			if(addAllItem){
				org.children.push({
						text: "整个单位",
						value: org.department_id
					});
			}
			
			for(var j in allList){
				var dept = allList[j];
				if(dept.category_type!='organization' && dept.organization_id==org.value){
					org.children.push({
						text: dept.category_name,
						value: dept.department_id
					});
				}
			}
		}
		return list;
	}
	
	owner.getOrgWithChildren = function(parentId){
		parentId = parseInt(parentId);
		var cached = sessionStorage.getItem("org:"+parentId);
		if(!cached)
		{
			var allList = owner.str2Json(plus.storage.getItem("$orgList"));
			cached = new Array();
			cate = null;
			for(var i in allList)
			{
				var item = allList[i];
				if(item.department_id==parentId){
					cate = item;
				}
				else if(item.parent_id==parentId){
					cached.push(item);
				}
			}
			if(parentId==0){
				cate = {department_id:0,category_name:'组织架构', parent_id:-1, category_route_name:'/全部部门/', children:[]};
			}
			if(cate)
			{
				cate.children = cached;
			}
			sessionStorage.setItem("org:"+parentId, JSON.stringify(cate));
			return cate;
		}
		else
		{
			return JSON.parse(cached);
		}
	};
	
	owner.getContactById = function (contactId){
		var contacts = app.getContacts();
		for(var i in contacts)
		{
			var item = contacts[i];
			if(item && item.contact_id==contactId)
			{
				return item;
			}
		}
		return null;
	};
	
	owner.getContactByUserId = function (userId){
		var contacts = app.getContacts();
		for(var i in contacts)
		{
			var item = contacts[i];
			if(item && item.related_entity_id==userId)
			{
				return item;
			}
		}
		return null;
	};
	
	// 重新从服务器获取某联系人信息
	owner.refreshContactById = function(contactId, callback){
		resources.contacts.read(contactId).done(function(data){
			owner.setContactById(contactId, data);
			if(callback){
				callback(data);
			}
		});
	};
	
	owner.deleteContactById = function(contactId){
		var contacts = app.getContacts();
		var found = false;
		for(var i in contacts)
		{
			if(contacts[i] && contacts[i].contact_id==contactId)
			{
				contacts.splice(i, 1);
				found = true;
				break;
			}
		}
		if(!found){
			console.log("delete contact "+contactId+" in $sysContacts not found");
			
		}
		plus.storage.setItem("$sysContacts", JSON.stringify(contacts));	
	};
	//重新设置某联系人信息
	owner.setContactById = function(contactId, item){
		var contacts = app.getContacts();
		var found = false;
		for(var i in contacts)
		{
			if(contacts[i] && contacts[i].contact_id==contactId)
			{
				contacts[i] = item;
				found = true;
				break;
			}
		}
		if(!found){
			console.log("add new contact to $sysContacts:"+item.contact_id+" owner:"+item.owner_user_id);
			contacts.push(item);
		}
		plus.storage.setItem("$sysContacts", JSON.stringify(contacts));	
		if(item.myFollowingRelation){
			owner.syncToLocalContact(item, true);
		}
	};
	
	//根据工号获取联系人信息
	owner.getContactByEmployeeNumber = function (employeeNumber){
		var contacts = app.getContacts();
		for(var i in contacts)
		{
			var item = contacts[i];
			if(item && item.employee_number==employeeNumber)
			{
				return item;
			}
		}
		return null;
	};
	
	owner.getLocalAnnouncements = function(isAdmin){
		var list = owner.getLocalAnnouncements();
		list.sort(function(a,b){return a.published_at>b.published?1:-1});
		if(!isAdmin){
			var resultList = [];
			for(var i in list){
				var item = list[i];
				if(item.announcement_status=='published'){
					
				}
			}
		}
		return list;
	};
	
	owner.deleteLocalAnnouncementById = function(id){
		var list = owner.getLocalAnnouncements();
		for(var i in list){
			if(list[i] && list[i].announcement_id==id)
			{
				list.splice(i,1);
				return;
			}
		}
	};
	
	owner.getLocalAnnouncementById = function(id){
		var list = owner.getLocalAnnouncements();
		for(var i in list){
			if(list[i] && list[i].announcement_id==id)
			{
				return list[i];
			}
		}
		return null;
	};
	
	//重新设置某联系人信息, 如不存在则返回false，以便决定从头部或尾部插入
	owner.setExistLocalAnnouncementById = function(id, item){
		var contacts = app.getLocalAnnouncements();
		var found = false;
		for(var i in contacts)
		{
			if(contacts[i] && contacts[i].announcement_id==id)
			{
				contacts[i] = item;
				found = true;
				break;
			}
		}
		if(!found){
			contacts.push(item);
		}
		plus.storage.setItem("$announcements", JSON.stringify(contacts));	
	};
	
	
	owner.getLocalNotifications = function(){
		var textVal = plus.storage.getItem("$notifications");
		return owner.str2Json(textVal, []);
	};
	
	owner.getLocalNotificationById = function (notificationId){
		var notifications = owner.getLocalNotifications();
		for(var i in notifications){
			if(notifications[i] && notifications[i].notification_id==notificationId)
			{
				return notifications[i];
			}
		}
		return null;
	};
	
	//重新设置某联系人信息
	owner.setLocalNotificationById = function(notificationId, item){
		var contacts = app.getLocalNotifications();
		var found = false;
		for(var i in contacts)
		{
			if(contacts[i] && contacts[i].notification_id==notificationId)
			{
				contacts[i] = item;
				found = true;
				break;
			}
		}
		if(!found){
			console.log("add new notifications to $notifications:"+item.notification_id);
			contacts.push(item);
		}
		plus.storage.setItem("$notifications", JSON.stringify(contacts));	
	};
	
	owner.str2Json = function(strVal, defaultVal){
		if(strVal){
			try{
				strVal = strVal.replace(/\\/g,"/");
				//mui.alert(contactText);
				jsonVal = JSON.parse(strVal);
//				mui.toast("共有"+contacts.length+"个联系人");
				//mui.toast(contacts.length);
				return jsonVal;
			}
			catch(e){
				mui.toast("str2Json failed");
				return defaultVal;
//				mui.alert(e.name);
//				mui.alert(e.message);
//				mui.alert(e.description);
			}
		}
		return defaultVal;
	};
	
	owner.getSysContacts = function(){
		var contactText = plus.storage.getItem("$sysContacts");
		var contacts = [];
		if(contactText){
			contacts = owner.str2Json(contactText, []);
			//mui.toast("got contact count:"+contacts.length);
		}
		else{ 
			console.log("not found sysContacts:"+contactText);
			mui.toast("没有联系人数据"+contactText);
		}
		return contacts;
	}
	
	/**
	 * 获取部门下直接联系人列表（不包含子部门） 
	 * @param {Object} deptId
	 */
	owner.getContactsByDept = function(deptId)
	{
		deptId = parseInt(deptId);
		var cached = sessionStorage.getItem("contacts:"+deptId);
		if(!cached)
		{
			var allList = owner.getSysContacts();
			cached = new Array();
			cate = null;
			// 先找出领导
			for(var i in allList)
			{
				var item = allList[i];
				if(!item.is_leader){
					continue;
				}
				if(item.owner_user_id!=0 && item.share_status!=2){
					continue;
				}
				if(item.category_id==deptId){
					cached.push(item);
				}
			}
			for(var i in allList)
			{
				var item = allList[i];
				if(item.is_leader){
					continue;
				}
				if(item.owner_user_id!=0 && item.share_status!=2){
					continue;
				}
				if(item.category_id==deptId){
					cached.push(item);
				}
			}
			sessionStorage.setItem("contacts:"+deptId, JSON.stringify(cached));
			return cached;
		}
		else
		{
			return owner.str2Json(cached);
		}
	};
	
	
	owner.getIndexedSysContacts = function(departmentId,keyword,includingSubDept){
		var indexedList = [];
		
		indexedList[0] = {index:'star', label:'收藏',items:[]};
		
		for(var i=65;i<=90;i++)
		{
			var charIndex = i-64;
			var theChar = String.fromCharCode(i);
			indexedList[charIndex] = {index:theChar, label:theChar,items:[]};
		}
		indexedList[91-64] = {index:'other',label:'#',items:[]};
		var contacts = owner.getSysContacts();
		
//		var localContacts = owner.getContacts()
		if(contacts && contacts instanceof Array){
			for(var i = 0 ; i<contacts.length; i++)
			{
				var item = contacts[i];
				if(item.owner_user_id!=0 && item.share_status!=2){
					continue;
				}
				
				if(departmentId && departmentId>0 && item.category_id!=departmentId){
					if(includingSubDept && item.category && item.category.category_route 
						&& item.category.category_route.indexOf("/"+departmentId+"/")>=0)
					{
						// can stay, nothing to do.
					}
					else{
						continue;
					}
				}
				var inPinyin = false;
				if(item.contact_pinyin){
					inPinyin = item.contact_pinyin.indexOf(keyword)>=0;
				}
				var inFirstPinyin = false;
				if(item.contact_first_pinyin){
					inFirstPinyin = item.contact_first_pinyin.indexOf(keyword)>=0;
				}
				var inPosition = false;
				if(item.position_name){
					inPosition = item.position_name.indexOf(keyword)>=0;
				}
				var inFields = false;
				for(var j in item.contactFields){
					var field = item.contactFields[j];
					if(field.field_value){
						console.log("search field:"+field.field_value);
						inFields = field.field_value.indexOf(keyword)>=0;
						if(inFields){
							break;
						}
					}
				}
//				console.log('item:'+item.contact_name+' '+item.category_id);
				if(keyword && item.contact_name.indexOf(keyword)==-1 
					&& !inPinyin && !inFirstPinyin && !inPosition && !inFields){
					continue;
				}
				
				if(item.contact_pinyin && item.contact_pinyin[0]){
					var firstPinyin = item.contact_pinyin[0].toUpperCase();
					var charIndex = firstPinyin.charCodeAt();
	//				console.log(charIndex);
					if(charIndex<65 || charIndex>90)
					{
						charIndex = 91-64;
					}
					else{
						charIndex = charIndex-64;
					}
				}
				else{
					charIndex = 91-64;
				}
				indexedList[charIndex].items.push(item);
				// the starred contact should insert into star set.
				if(item.myStarredRelation!=null){
					indexedList[0].items.push(item);
				}
			}
		}
		
		return indexedList;
	}
	
	// 获取我的常联系人（包括我创建的，我收藏的，同步到手机联系人的）
	owner.getIndexedMyContacts = function(departmentId,keyword){
		var indexedList = [];
		
		indexedList[0] = {index:'star', label:'收藏',items:[]};
		
		for(var i=65;i<=90;i++)
		{
			var charIndex = i-64;
			var theChar = String.fromCharCode(i);
			indexedList[charIndex] = {index:theChar, label:theChar,items:[]};
		}
		indexedList[91-64] = {index:'other',label:'#',items:[]};
		
		var contacts = owner.getSysContacts();
		
		var user = owner.getUser();
		console.log("current user:"+JSON.stringify(user));
		console.log("sysContacts:"+contacts.length);
//		mui.toast("got user");
//		var localContacts = owner.getContacts()
		if(contacts && contacts instanceof Array){
			for(var i = 0 ; i<contacts.length; i++)
			{
				var item = contacts[i];
				if(!item.myFollowingRelation && !item.myStarredRelation && item.owner_user_id!=user.user_id){
					continue;
				}
				if(departmentId && departmentId>0 && item.category_id!=departmentId){
					continue;
				}
				var inPinyin = false;
				if(item.contact_pinyin){
					inPinyin = item.contact_pinyin.indexOf(keyword)>=0;
				}
				var inFirstPinyin = false;
				if(item.contact_first_pinyin){
					inFirstPinyin = item.contact_first_pinyin.indexOf(keyword)>=0;
				}
				var inPosition = false;
				if(item.position_name){
					inPosition = item.position_name.indexOf(keyword)>=0;
				}
//				console.log('item:'+item.contact_name+' '+item.category_id);
				if(keyword && item.contact_name.indexOf(keyword)==-1 && !inPinyin && !inFirstPinyin && !inPosition){
					continue;
				}
				if(item.contact_pinyin && item.contact_pinyin[0]){
					var firstPinyin = item.contact_pinyin[0].toUpperCase();
					var charIndex = firstPinyin.charCodeAt();
	//				console.log(charIndex);
					if(charIndex<65 || charIndex>90)
					{
						charIndex = 91-64;
					}
					else{
						charIndex = charIndex-64;
					}
				}
				else{
					charIndex = 91-64;
				}
				// the starred contact should insert into star set.
				if(item.myStarredRelation!=null){
					indexedList[0].items.push(item);
				}
				else{
					indexedList[charIndex].items.push(item);
				}
			}
		}
		
		return indexedList;
	}
	
	/**
	 * 获取按拼音首字母分类的本地手机联系人列表 
	 */
	owner.getIndexedLocalContacts = function(localContacts){
		var indexedList = [];
		
		indexedList[0] = {index:'star', label:'收藏',items:[]};
		
		for(var i=65;i<=90;i++)
		{
			var charIndex = i-64;
			var theChar = String.fromCharCode(i);
			indexedList[charIndex] = {index:theChar, label:theChar,items:[]};
		}
		indexedList[91-64] = {index:'#',label:'#',items:[]};

		// 手机联系人
		if(!localContacts || !(localContacts instanceof Array)){
			console.log("parameter localContacts is not a Array")
			return indexedList;
		}
		
		console.log("got local contact :"+localContacts.length);
		
		for(var i in localContacts){
			var item = localContacts[i];
//			console.log(JSON.stringify(item));
			
			if(item.contact_pinyin && item.contact_pinyin.length>0){
				var firstPinyin = item.contact_pinyin[0].toUpperCase();
				var charIndex = firstPinyin.charCodeAt();
	//				console.log(charIndex);
				if(charIndex<65 || charIndex>90)
				{
					charIndex = 91-64;
				}
				else{
					charIndex = charIndex-64;
				}
			}
			else{
				charIndex = 91-64;
			}
			indexedList[charIndex].items.push(item);
		}
		
		return indexedList;
	}
	
	owner.buildIndexedContactsHtml = function(myContacts){		
//		if(departmentId<=0 && !keyword){
//			
//			var cached = plus.storage.getItem("$sysContactsHtml");
//			if(cached)
//			{
//				//return cached;
//			}
//		}
		
//					console.log(myContacts.length);
		var html = '';
		for(var i=0;i<myContacts.length;i++)
		{
			var sub = myContacts[i];
			var indexVal = sub.index;
			var indexLabel = sub.label;
//			console.log("sub:"+sub.label+" "+sub.items.length);
			if(sub.items instanceof Array && (sub.items.length>0)){
				if(indexLabel=='收藏'){
					html+="<li data-group=\""+indexVal+"\" class=\"mui-table-view-divider mui-indexed-list-group\">\n"
						+"<span class=\"mui-icon mui-icon-star\" style='color:darkorange;font-size:16px'><span></li>\n";
				}
				else{
					html+="<li data-group=\""+indexVal+"\" class=\"mui-table-view-divider mui-indexed-list-group\">\n"
						+"<span>"+indexLabel+"<span></li>\n";
				}
				for(var j=0;j<sub.items.length;j++)
				{
					var item = sub.items[j];
					
//					console.log(JSON.stringify(item));
					var imgUrl = app.getContactAvatar(item, 64);
					var positionName = item.position_name ? item.position_name : '';
					if(item.category && item.category.category_name){
						positionName = item.category.category_name + " / "+positionName;
					}
					html+=("<li data-value='"+item.contact_pinyin+" "+item.contact_first_pinyin
						+"' data-id='"+  item.contact_id
						+"' data-group-index='"+  i
						+"' data-index='"+  j
						+"' data-tags='"+positionName+"' \
						class='mui-table-view-cell mui-indexed-list-item contact-item mui-media'>"
						+ '<a href="javascript:;">\
						<img class="contact-avatar mui-media-object mui-pull-left" src="' + imgUrl
						+ '"><div class="mui-media-body">'
						+item.contact_name
						+ "<p class='mui-ellipsis'>"+positionName+"</p>"
						+"</div></a>\
						</li>\n");
				}
			}
//			else{
//				console.log("empty sub "+sub.label);
//				console.log(JSON.stringify(sub.items ));
//			}
		}
//		plus.storage.setItem("$sysContactsHtml", html);
		return html;
	}
	
	/**
	 * 更新本地联系人数据库 
	 * @param {Object} data
	 */
	owner.refreshLocalContacts_SQLITE = function(data){
		var xhr = new XMLHttpRequest();
		xhr.open('GET', 'libs/db.sqlite', true);//在App中的相对路径
		xhr.responseType = 'arraybuffer';
		
		xhr.onload = function(e) {
			var uInt8Array = new Uint8Array(this.response);
			var db = new SQL.Database(uInt8Array);
			var contents = db.exec("DELETE * FROM contacts");//执行查询语句
			
			console.log(contents[0]);
			if(data && data.length>0){
				for(var i=0;i<data.length;i++)
				{
					var item = data[i];
					console.log(item);
					//TODO:insert into local db
				}
			}
		};
		xhr.send();
	}
	
	owner.sendSMS = function(toNumbers, msgContent, successCallback, failedCallback){
		//短信
		var msg = plus.messaging.createMessage(plus.messaging.TYPE_SMS);
		if(toNumbers instanceof Array)
		{
			msg.to = toNumbers;
		}
		else if(toNumbers instanceof String)
		{
			msg.to = toNumbers.split(',');
		}
		else{
			console.log("invalid type of :"+toNumbers);
		}
		console.log("to:"+JSON.stringify(msg.to));
		msg.body = msgContent;
		plus.messaging.sendMessage( msg , successCallback, failedCallback);
	};
	
	owner.sendEMail = function(toEmails, msgContent, successCallback, failedCallback){
		//短信
		var msg = plus.messaging.createMessage(plus.messaging.TYPE_EMAIL);
		if(toEmails instanceof Array)
		{
			msg.to = toEmails;
		}
		else if(toNumbers instanceof String)
		{
			msg.to = toEmails.split(',');
		}
		else{
			console.log("invalid type of :"+toEmails);
		}
		msg.body = msgContent;
		plus.messaging.sendMessage( msg , successCallback, failedCallback);
	};
	
	/**
	 * 复制文本到剪贴板 
	 */
	owner.copyToClipboard = function(textValue) {
		if(plus.os.name=="iOS"){
			var UIPasteboard  = plus.ios.importClass("UIPasteboard");
			//这步会有异常因为UIPasteboard是不允许init的，init的问题会在新版中修改
			var generalPasteboard = UIPasteboard.generalPasteboard();
			// 设置/获取文本内容:
			generalPasteboard.setValueforPasteboardType(textValue, "public.utf8-plain-text");
//			var value = generalPasteboard.valueForPasteboardType("public.utf8-plain-text");   
		}
		else if(plus.os.name=="Android"){
		    var Context = plus.android.importClass("android.content.Context");
		    var main = plus.android.runtimeMainActivity();
		    var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
		    plus.android.invoke(clip,"setText",textValue);
		}
		else{
			console.log("invalid os: "+plus.os.name);
		}
	};
	
	owner.getDepartmentAvatar = function(dept, size){
		var img = 'images/contact5-group2-64.jpg';
		if(dept.category_type=='organization'){
			img = 'images/contact5-org-64.jpg';
		}
		else if(dept.category_type=='group'){
			img = 'images/contact5-folder-64.jpg';
		}
		if(plus.networkinfo.getCurrentType()!=plus.networkinfo.CONNECTION_NONE 
			&& dept.mainImageUrl && dept.mainImageUrl!=null && dept.mainImageUrl!=undefined)
		{
			img = dept.mainImageUrl;
			if(size){
				img += "/adaptive/"+size;
			}
		}
		return img;
	};
	
	owner.getContactAvatar = function(contact, size){
		
		var genderImg = 'images/contact1-unknown-64.jpg';
		if(contact.gender=='female'){
			genderImg = 'images/contact5-female-64.jpg';
		}
		else{
			genderImg = 'images/contact5-male-64.jpg';
		}
		if(plus.networkinfo.getCurrentType()!=plus.networkinfo.CONNECTION_NONE 
			&& contact.avatarUrl && contact.avatarUrl!=null && contact.avatarUrl!=undefined)
		{
			genderImg = contact.avatarUrl;
			if(size){
				genderImg += "/adaptive/"+size;
			}
		}
		return genderImg;
	};
	
	owner.localContactToContact = function(loc){
//		console.log(JSON.stringify(loc));
		var c = {};
		c.contact_name = loc["displayName"]?loc["displayName"]:'';
		c.contact_pinyin = pinyin.getCamelChars(c.contact_name);
		c.contact_first_pinyin = pinyin.getFullChars(c.contact_name);
		if(!loc["displayName"]){
//			console.log(JSON.stringify(loc));
//			console.log(JSON.stringify(c));
			return null;
		}
		return c;
	};
	
	owner.loadLocalContacts = function(refresh, callback){
		if(!refresh){
			var localContacts = owner.str2Json(plus.storage.getItem('$localContacts'));
			if(localContacts && localContacts instanceof Array){
				if(callback){
					callback(localContacts);
				}
			}
		}
		console.log('begin to load local contacts from phone');
		plus.contacts.getAddressBook( plus.contacts.ADDRESSBOOK_PHONE, 
			function( addressbook ) {
				// 可通过addressbook进行通讯录操作
				var contact = addressbook.find( null, 
					function ( contacts ) {
						var localContacts = [];
						if ( contacts.length> 0 ) {
							console.log("found contacts in loadLocalContacts:"+contacts.length);
//							console.log(JSON.stringify(contacts));
							for(var i in contacts){
								var item = owner.localContactToContact(contacts[i]);
								if(item){
									localContacts.push(item);
								}
							}
							plus.storage.setItem('$localContacts',JSON.stringify(localContacts));
						};
						if(callback){
							callback(localContacts);
						}
					},
					function ( e ) {
						alert( "Find contact error: " + e.message );
					}, 
					{filter:[],multi:true} //{logic:"or",field:"phoneNumbers",value:"88888888"}
				);
			} ,
			function(){
				console.log("get addressbook failed");
			}
		);
	};
	
	owner.setLocalContactId = function(contactId, localContactId, updatedAt){
		var mapText = plus.storage.getItem("$localContactMaps");
		var mapObj = owner.str2Json(mapText, []);
		mapObj[contactId] = {
			local_id: localContactId,
			updated_at: updatedAt
		};
		
		plus.storage.setItem("$localContactMaps", JSON.stringify(mapObj));
	};
	
	owner.getLocalContactInfoByContactId = function(contactId){
		var mapText = plus.storage.getItem("$localContactMaps");
		var mapObj = owner.str2Json(mapText, []);
		if(mapObj[contactId]){
			return mapObj[contactId];
		}
		return {local_id:0, updated_at:0};
	};
	
	owner.syncToLocalContact = function (item, skipForUpdateTime){
		console.log("finding "+item.employee_number);
		//查找是否存在
		plus.contacts.getAddressBook( plus.contacts.ADDRESSBOOK_PHONE, 
			function( addressbook ) {
				// 可通过addressbook进行通讯录操作
				var localContactInfo = owner.getLocalContactInfoByContactId(item.contactId);
				if(skipForUpdateTime){
					if(localContactInfo.local_id>0 && localContactInfo.updated_at==item.updated_at){
						console.log("skip sync for updated_at same");
						return;
					}
				}
				
				console.log("find the contact:"+item.contact_id+" "+" local:"+localContactInfo.local_id+" "+item.contact_name);
				var foundResult = addressbook.find( null, 
					function ( foundContacts ) {
						console.log("found count:"+foundContacts.length);
						console.log(JSON.stringify(foundContacts));
						var loc = null;
						if(!foundContacts || foundContacts.length==0){
							//没有找到，创建一个新的
							loc = addressbook.create();
							loc.identifiers = [
								{type:"employee_number", value:item.employee_number},
//								{type:"contact_id", value:item.contact_id}
								];
							loc.ims = [
								{type:"employee_number", value:item.employee_number},
//								{type:"contact_id", value:item.contact_id}
							];
							
						}
						else{
							console.log("already in phone contact");
							loc = foundContacts[0];
						}
						if(!loc){
							console.log("no contact be found or created");
							return;
						}
						loc.name = {givenName:item.contact_name};
						loc.displayName = item.contact_name;
						loc.phoneNumbers = [];//[{type:"手机",value:item.mobile,preferred:true}];
						loc.addresses = [];
						loc.emails = [];
						loc.organizations = [];
						loc.urls = [];
						loc.note ='';
						//loc.others = [{type:"工号",value:item.employee_number,preferred:true}];
						if(item.contactFields && (item.contactFields instanceof Array||item.contactFields instanceof Object)){
							for(var i in item.contactFields)
							{
								var exField = item.contactFields[i];
		//						console.log(exField.rules);
								if(exField.field_value)
								{
									var fieldTypeName = owner.getFieldTypeName(exField);
									if(exField.field_domain=="phoneNumbers"){
										loc.phoneNumbers.push(
											{type:exField.field_type, 
												value:exField.field_value, preferred:exField.is_preferred}
										);
									}
									else if(exField.field_domain=='emails'){
										loc.emails.push(
											{type:exField.field_type, value:exField.field_value, preferred:exField.is_preferred}
										);
									}
									else if(exField.field_domain=='urls'){
										loc.urls.push(
											{type:exField.field_type, value:exField.field_value, preferred:exField.is_preferred}
										);
									}
									else if(exField.field_domain=='ims'){
										loc.ims.push(
											{type:exField.field_type, value:exField.field_value, preferred:exField.is_preferred}
										);
									}
									else if(exField.field_domain=='addresses'){
										loc.addresses.push(
											{type:exField.field_type, formatted:exField.field_value, preferred:exField.is_preferred}
										);
									}
									else{
										loc.note += fieldTypeName+": "+exField.field_value+"\n";
										console.log("note fields "+JSON.stringify(exField));
									}
								}
							}
						}

						loc.save(function(res){
							owner.setLocalContactId(item.contact_id, res.id, item.updated_at);
							console.log("saved local contact:"+JSON.stringify(res));
						}, function(res){
							console.log(JSON.stringify(res));
						});
						
					},
					function ( e ) {
						alert( "Find contact error: " + e.message );
					}, 
					{filter:[
						{logic:"and",field:"id",value:localContactInfo.local_id},
//						{logic:"and",field:"phoneNumbers",value:item.mobile}
					],multi:false} //{logic:"or",field:"phoneNumbers",value:"88888888"}
				);
			} ,
			function(){
				alert("访问手机通讯录失败，请在系统弹出提示时允许应用访问手机联系人");
			}
		);
	}
	
	owner.reloadNotifications = function(){
		var contactPage = plus.webview.getWebviewById('tab-webview-announce-list.html');
		contactPage.evalJS("reloadData()");
	};
	
	owner.reloadMyContacts = function(){
		var contactPage = plus.webview.getWebviewById('tab-webview-contact.html');
		contactPage.evalJS("reloadData()");
	};
	
	owner.getDefaultTypeName = function(type){
		var types = {
			'mobile':'手机',
			'home':'家庭',
			'company':'公司',
			'short':'短号',
			'home_fax':'家庭传真',
			'company_fax':'公司传真',
			'ohter':'其他',
			'custom':'自定义',
			'url':'网站',
			'QQ':'QQ',
			'SKYPE':'Skype',
			'ALI':'旺旺',
			'photo':'照片',
			'note':'备注'
		};
		if(types[type]){
			return types[type];
		}
		return type;
	};
	
	owner.getFieldTypeName = function (field){
		
		if(field.field_type=='custom'){
			return field.field_name;
		}
		return owner.getDefaultTypeName(field.field_type);
	};
	
	owner.getDomains = function(){
		return ['phoneNumbers','emails','addresses','urls','ims','notes'];
	};
	
	owner.getDomainNames = function(){
		return {
			'phoneNumbers':'电话号码',
			'emails':'邮件',
			'addresses':'地址',
			'urls':'网站',
			'ims':'即时通讯',
			'notes':'备注',
		};
	};
	
	owner.getDomainName = function (domain){
		var types = owner.getDomainNames();
		console.log(domain+' ' + types[domain]); 
		if(types[domain]){
			return types[domain];
		} 
		return domain;
	};
	
	owner.openWindow = function(id, url, extras){
		
		var aniShow = "pop-in";
		//不使用父子模板方案的页面
		var webview_style = {
			popGesture: "close"
		};
		mui.openWindow({
			id: id,
			url: url,
			styles: webview_style,
			waiting: {
				autoShow: aniShow
			},
			extras:extras
		});
	}
}(mui, window.app = {}));